module Gared
  class Hebrewbooks
    require 'watir'

    def initialize
      @browser = Watir::Browser.new :chrome, options: {args: ['--no-sandbox', '--headless']}
    end

    def query_persons(q)
    end

    def query_person(person)
    end

    def query_publications(q)
    end

    def query_publication(publication)
    end

    def query_publications_by_person(person, ctx = nil)
      @browser.goto 'http://hebrewbooks.org/home.aspx'
      @browser.wait
      t = @browser.text_field(id: 'cpMstr_author')
      t.set(person)
      @browser.form(id: 'form1').submit # get publications by person
      @browser.wait
      trs = @browser.div(id: 'dbresults').trs
      ret = []
      if trs.size > 0
        trs.each do |tr|
          p = Publication.new(ctx)
          p.title = tr.tds[0].text
          p.author_line = tr.tds[1].text
          p.source_id = tr.tds[0].a.href
          p.scanned = true
          h = Holding.new
          h.source_id = tr.tds[0].a.href
          h.source_name = 'Hebrewbooks'
          h.scan_url = "http://download.hebrewbooks.org/downloadhandler.ashx?req=#{h.source_id.rpartition('=')[2]}"
          p.add_holding(h)
          ret << p
        end
      end
      return ret
      # TODO: support multiple result pages
    end
  end
end